config/routes.rb
Rails.application.routes.draw do
 resources :articles
root 'pages#index'
   get 'about', to: 'pages#about'
   get 'signup', to: 'users#new'
   resources :users, except: [:new]
   get 'login', to: 'sessions#new'
   post 'login', to: 'sessions#create'
 delete 'logout', to: 'sessions#destroy'

 resources :tags, only: [:show]
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  self.abstract_class = true
end

app/models/article.rb
class Article < ActiveRecord::Base
  has_many :taggings, dependent: :destroy
  has_many :tags, through: :taggings, dependent: :destroy
  belongs_to :user
  validates :title, presence: true, length: { minimum: 3, maximum: 50 }
  validates :description, presence: true, length: { minimum: 10, maximum: 3000 }
  validates :user_id, presence: true

  def all_tags
    self.tags.map(&:name).join(', ')
  end

  def all_tags=(names)
    self.tags = names.split(',').map do |name|
      Tag.where(name: name.strip).first_or_create!
    end
  end

  # mount for images
  mount_uploader :image, ImageUploader

end

app/models/tag.rb
class Tag < ApplicationRecord
  has_many :taggings
  has_many :articles, through: :taggings

  def self.counts
    self.select("name, count(taggings.tag_id) as count").joins(:taggings).group("taggings.tag_id")
  end
end

app/models/tagging.rb
class Tagging < ApplicationRecord
  belongs_to :article
  belongs_to :tag
end

app/models/user.rb
class User < ActiveRecord::Base
  VALID_EMAIL_REGEX = /\A[\w+\-.]+@[a-z\d\-.]+\.[a-z]+\z/i
  has_many :articles
  has_secure_password
  validates :username, presence: true, uniqueness: { case_sensitive: false }, length: { minimum: 3, maximum: 25 }
  validates :email, presence: true, length: { maximum: 105 }, uniqueness: { case_sensitive: false },
  format: { with: VALID_EMAIL_REGEX }
  before_save { self.email = email.downcase }
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  helper_method :current_user, :logged_in?

  def current_user
    @current_user ||= User.find(session[:user_id]) if session[:user_id]
  end

  def logged_in?
    !!current_user
  end

  def require_user
    if !logged_in?
      flash[:danger] = "You must be logged in to perform that action"
      redirect_to root_path
    end
  end
end

app/controllers/articles_controller.rb
class ArticlesController < ApplicationController
  before_action :set_article, only: [:edit, :update, :show, :destroy]
def new
  @article = Article.new
end

def create
  @article = Article.new(article_params)
  @article.user = User.first
  if @article.save
   flash[:notice] = "Article was successfully created"
   redirect_to article_path(@article)
  else
   render 'new'
  end
end

def show
end

def update
  if @article.update(article_params)
   flash[:success] = "Article was updated"
   redirect_to article_path(@article)
  else
   flash[:success] = "Article was not updated"
   render 'edit'
  end
end

def edit
end

def index
  @articles = Article.paginate(page: params[:page], per_page: 5)
end

def destroy
  @article.destroy
  flash[:success] = "Article was deleted"
  redirect_to articles_path
end

private
  def article_params
   params.require(:article).permit(:title, :description, :all_tags, :image)
  end
def set_article
   @article = Article.find(params[:id])
  end
end

app/controllers/pages_controller.rb
class PagesController < ApplicationController
  def index
  end
  def about
  end
end

app/controllers/sessions_controller.rb
class SessionsController < ApplicationController
  def new
  end

  def create
    user = User.find_by(email: params[:session][:email].downcase)
    if user  && user.authenticate(params[:session][:password])
      session[:user_id] = user.id
      flash[:success] = "You have logged in"
      redirect_to users_path(user)
    else
      flash.now[:danger] = "There was something wrong with your login information"
      render 'new'
    end
  end

  def destroy
    session[:user_id] = nil
    flash[:success] = "You have logged out"
    redirect_to root_path
  end
end

app/controllers/tags_controller.rb
class TagsController < ApplicationController
  def show
    @tag = Tag.find_by(name: params[:id])
    @articles = @tag.articles
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  def new
    @user = User.new
  end

  def create
    @user = User.new(user_params)
    if @user.save
     flash[:success] = "Welcome to the alpha blog #{@user.username}"
     redirect_to articles_path
    else
     render 'new'
    end
  end

  def update
    @user = User.find(params[:id])
    if @user.update(user_params)
      flash[:success] = "Your account was updated successfully"
      redirect_to articles_path
    else
      render 'edit'
    end
  end

  def edit
    @user = User.find(params[:id])
  end

  def show
    @user = User.find(params[:id])
    @user_articles = @user.articles.paginate(page: params[:page], per_page: 5)
   end

  def index
    @users = User.paginate(page: params[:page], per_page: 5)
  end

  private
  def user_params
    params.require(:user).permit(:username, :email, :password)
  end

end

app/helpers/application_helper.rb
module ApplicationHelper
 def gravatar_for(user, options = { size: 80})
  gravatar_id = Digest::MD5::hexdigest(user.email.downcase)
  size = options[:size]
  gravatar_url = "https://secure.gravatar.com/avatar/#{gravatar_id}?s=#{size}"
  image_tag(gravatar_url, alt: user.username, class: "img-circle")
 end
end

app/helpers/article_helper.rb
module ArticleHelper
  def tag_cloud(tags, classes)
    max = tags.sort_by(&:count).last
    tags.each do |tag|
      index = tag.count.to_f / max.count * (classes.size-1)
      yield(tag, classes[index.round])
    end
  end
end

app/views/articles/_disqus.html.erb
<div class="well col-xs-8 col-xs-offset-2">
    <div id="disqus_thread"></div>
        <script>
            var disqus_config = function () {
<<<<<<< HEAD
                this.page.url = 'http://localhost.com<%= request.original_fullpath %>';
=======
                this.page.url = '<%= request.base.url + request.original_fullpath %>';
>>>>>>> a82e6737cc1c8ad6e5c039a321b9d4b394222b9a
                this.page.identifier = '<%= @article.id %>';
            };

            (function() { // DON'T EDIT BELOW THIS LINE
                var d = document, s = d.createElement('script');
                s.src = 'https://myblog-xfehcqmtra.disqus.com/embed.js';
                s.setAttribute('data-timestamp', +new Date());
                (d.head || d.body).appendChild(s);
            })();
        </script>
    <noscript>Please enable JavaScript to view the <a href="https://disqus.com/?ref_noscript">comments powered by Disqus.</a></noscript>
</div>

app/views/articles/_form.html.erb
<%= render 'shared/errors', obj: @article %>
<div class="row">
 <div class="col-xs-12">

  <%= form_for(@article, :html => { multipart: true, class: "form-horizontal", role: "form"}) do |f| %>
  <div class="form-group">
   <div class="control-label col-sm-2">
    <%= f.label :title %>
   </div>
   <div class="col-sm-6">
    <%= f.text_field :title, class: "form-control", placeholder: "Title of article", autofocus: true %>
   </div>
  </div>

<!--div for tags-->
  <div class="form-group">
   <div class="control-label col-sm-2">
    <%= f.label :all_tags %>
   </div>
   <div class="col-sm-6">
    <%= f.text_field :all_tags, class: "form-control" %>
   </div>
  </div>

<!--div for images-->
  <div class="form-group" >
    <div class="control-label col-sm-2">

    </div>
    <div class="control-label col-sm-2">
      <%= f.file_field :image%>
    </div>
  </div>

<!--div for descripion-->
  <div class="form-group">
   <div class="control-label col-sm-2">
    <%= f.label :description %>
   </div>
   <div class="col-sm-6">
    <%= f.text_area :description, rows: 10, class: "form-control", placeholder: "Body of article" %>
   </div>
  </div>
  <div class="form-group">
   <div class="col-sm-offset-2 col-sm-10">
    <%= f.submit class: 'btn btn-primary btn-large' %>
   </div>
  </div>
<% end %>

  <section class="footer-summary">
    <%= raw @article.tags.map(&:name).map{ |t| link_to t, tag_path(t), class: 'tag tag-primary' }.join(' ')%>
  </section>

 </div>
</div>

app/views/articles/edit.html.erb
<h1 align="center">Edit Article</h1>

<%= render 'form' %>

<%= link_to 'Back', articles_path %>

app/views/articles/index.html.erb
<h1 align="center">Listing all articles</h1>

<%= render 'shared/article', obj: @articles %>

<div align="center">
  <%= will_paginate %>
</div>

app/views/articles/new.html.erb
<h1 align="center">Create an Article</h1>
<%= render 'form' %>
<%= link_to 'Back', articles_path %>

app/views/articles/show.html.erb
<h2 align="center">Title: <%= @article.title %></h2>
<div class="well col-xs-8 col-xs-offset-2">
 <% if @article.user %>
 <ul class="listing">
  <div class="row" align="center">
   <div class="col-md-4 col-md-offset-4">
    <li><%= link_to gravatar_for(@article.user), user_path(@article.user) %></li>
    <li class="article-title"><%= link_to @article.user.username, user_path(@article.user) %></li>
    <li><small><%= pluralize(@article.user.articles.count, "article") if @article.user.articles %></small></li>
   </div>
  </div>
 </ul>
 <% end %>

  <%= image_tag @article.image.url(:large), class: 'img-show' if @article.image? %>
 <h4 class="center description"><strong>Description:</strong></h4>
 <hr>
 <%= simple_format(@article.description) %>
 <div class="article-actions">
 <%= link_to "Edit", edit_article_path(@article), class: "btn btn-xs btn-primary" %>
 <%= link_to "Delete", article_path(@article), method: :delete, data: { confirm: "Are you sure you want to delete this article?"}, class: "btn btn-xs btn-danger" %>
 <%= link_to "Back", articles_path, class: "btn btn-xs btn-success" %>
 </div>

</div>
<%= render 'disqus' %>

app/views/layouts/_navigation.html.erb
<nav class="navbar navbar-default">
  <div class="container-fluid">
    <!-- Brand and toggle get grouped for better mobile display -->
    <div class="navbar-header">
      <button type="button" class="navbar-toggle collapsed" data-toggle="collapse" data-target="#bs-example-navbar-collapse-1" aria-expanded="false">
        <span class="sr-only">Toggle navigation</span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
        <span class="icon-bar"></span>
      </button>
      <%= link_to "My Blog", root_path, class: "navbar-brand", id: "logo" %>
    </div>

    <!-- Collect the nav links, forms, and other content for toggling -->
    <div class="collapse navbar-collapse" id="bs-example-navbar-collapse-1">
      <ul class="nav navbar-nav">
        <li><%= link_to "Articles", articles_path %></li>
        <li><%= link_to "Create Article", new_article_path %></li>

      </ul>

      <ul class="nav navbar-nav navbar-right">
        <% if logged_in? %>
          <li><%= link_to "Log out", logout_path, method: :delete %></li>
        <% else %>
          <li><%= link_to "Log in", login_path, method: :get %></li>
          <li><%= link_to "Sign up", signup_path, method: :get %></li>
        <% end %>
      </ul>

    </div><!-- /.navbar-collapse -->
  </div><!-- /.container-fluid -->
</nav>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>Blog</title>
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag 'application', media: 'all', 'data-turbolinks-track': 'reload' %>
    <%= javascript_pack_tag 'application', 'data-turbolinks-track': 'reload' %>

  </head>

  <body>
    <%= render 'layouts/navigation' %>
    <div class="row">

      <div class="col-md-12">
        <%= yield %>
      </div>

    </div>
    <%= debug(params) if Rails.env.development? %>
  </body>
</html>

app/views/pages/about.html.erb
<h1>About Blog</h1>
<%= link_to 'Home', root_path %>
<p> This blog was created because Valentyn must pass control work from PII </p>

app/views/pages/index.html.erb
<h1>Welcome to Blog</h1>
<%= link_to 'About', about_path %>

app/views/shared/_article.html.erb
<% obj.each do |article| %>
  <div class="row">
    <div class="col-xs-8 col-xs-offset-2">
      <div class="well well-lg">
        <div class="article-title">
          <%= link_to article.title, article_path(article) %>
        </div>

        <!-- image section-->
        <section class="image-summary clearfix">
          <%= image_tag article.image.url(:thumb), class: 'img-thumbnail thumb' if article.image?%>
        </section>

        <div class="article-body">
          <%= truncate(article.description, length: 100) %>
          <div class="article-meta-details">
          <small>Created by: <%= article.user.username if article.user %>,
                    <%= time_ago_in_words(article.created_at) %> ago,
                    last updated: <%= time_ago_in_words(article.updated_at) %> ago</small>
          </div>
        </div>
        <div class="article-actions">
          <%= link_to "Edit", edit_article_path(article), class: "btn btn-xs btn-primary" %>
          <%= link_to "Delete", article_path(article), method: :delete, data: { confirm: "Are you sure you want to delete this article?"}, class: "btn btn-xs btn-danger" %>
        </div>

        <section class="footer-summary">
          <%= raw article.tags.map(&:name).map{ |t| link_to t, tag_path(t), class: 'tag tag-primary' }.join(' ')%>
        </section>
      </div>
    </div>
  </div>
<% end %>

app/views/shared/_errors.html.erb
<% if obj.errors.any? %>
 <div class="row">
  <div class="col-xs-8 col-xs-offset-2">
   <div class="panel panel-danger">
    <div class="panel-heading">
     <h2 class="panel-title">
      <%= pluralize(obj.errors.count, "error") %>
      prohibited this object from being saved:
     </h2>
     <div class="panel-body">
      <ul>
       <% obj.errors.full_messages.each do |msg|%>
        <li><%= msg %></li>
       <% end %>
      </ul>
     </div>
    </div>
   </div>
  </div>
 </div>
<% end %>

app/views/shared/_messages.html.erb
<div class="row">
 <div class="col-xs-10 col-xs-offset-1">
  <% flash.each do |name, msg| %>
  <div class='alert alert-<%= "#{name}" %>'>
   <a href="#" class="close" data-dismiss="alert">&#215;</a>
   <%= content_tag :div, msg, :id => "flash_#{name}" if msg.is_a?(String) %>
  </div>
  <% end %>
 </div>
</div>

app/views/tags/show.html.erb
<h1><%= @tag.name %></h1>

<% if @tag.articles.empty? %>
  <h2>no articles</h2>
<% else %>
  <%= render 'shared/article', obj: @tag.articles %>
<% end %>

app/views/users/_form.html.erb
<%= render 'shared/errors', obj: @user %>
<div class="row">
  <div class="col-xs-12">
    <%= form_for(@user, :html => {class: "form-horizontal", role: "form"}) do |f| %>
    <div class="form-group">
      <div class="control-label col-sm-2">
        <%= f.label :username %>
      </div>
      <div class="col-sm-8">
        <%= f.text_field :username, class: "form-control", placeholder: "Enter username", autofocus: true %>
      </div>
    </div>
    <div class="form-group">
      <div class="control-label col-sm-2">
        <%= f.label :email %>
      </div>
      <div class="col-sm-8">
        <%= f.email_field :email, class: "form-control", placeholder: "Enter email" %>
      </div>
    </div>
    <div class="form-group">
      <div class="control-label col-sm-2">
        <%= f.label :password %>
      </div>
      <div class="col-sm-8">
        <%= f.password_field :password, class: "form-control", placeholder: "Enter password" %>
      </div>
    </div>
    <div class="form-group">
     <div class="col-sm-offset-2 col-sm-10">
      <%= f.submit(@user.new_record?  ? "Sign up" : "Update account", class: 'btn btn-primary btn-large') %>
     </div>
  </div>
    <% end %>
    <div class="col-xs-4 col-xs-offset-2">
       <%= link_to 'Cancel request and Return to Articles Listing', articles_path %>
    </div>
  </div>
</div>

app/views/users/edit.html.erb
<h1 align="center">Edit User Account</h1>
<%= render 'form' %>

app/views/users/index.html.erb
<h1 align="center">All Users</h1>
<div align="center">

 <% @users.each do |user| %>
  <ul class="listing">
   <div class="row">
    <div class="well col-md-4 col-md-offset-4">
     <li><%= link_to gravatar_for(user), user_path(user) %></li>
     <li class="article-title"><%= link_to user.username, user_path(user) %></li>
     <li><small><%= pluralize(user.articles.count, "article") if user.articles %></small></li>
    </div>
   </div>
  </ul>
 <% end %>
<%= will_paginate %>
</div>

app/views/users/new.html.erb
<h1 align="center">Signup</h1>
<%= render 'form' %>

app/views/users/show.html.erb
<h1 align="center">Welcome to <%= @user.username %>'s page</h1>
<div class="row">
 <div class="col-md-4 col-md-offset-5 center">
  <%= gravatar_for @user, size: 150 %>
 </div>
</div>

<h4 align="center"><%= @user.username %>'s articles</h4>
<%= render 'shared/article', obj: @user.articles %>